=== release@v0.9.0/cmd/kubepkg/templates/latest/deb/kubernetes-cni/debian/control ===
Source: kubernetes-cni
Section: misc
Priority: optional
Maintainer: Kubernetes Authors <kubernetes-dev@googlegroups.com>
Build-Depends: curl, ca-certificates, debhelper (>= 8.0.0)
Standards-Version: 3.9.4
Homepage: https://kubernetes.io
Vcs-Git: https://github.com/kubernetes/kubernetes.git
Vcs-Browser: https://github.com/kubernetes/kubernetes

Package: kubernetes-cni
Architecture: {{ .BuildArch }}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Kubernetes CNI
 The binaries required to provision container networking
