=== release@v0.9.0/cmd/kubepkg/templates/latest/deb/cri-tools/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

build:
	echo noop

binary:
	mkdir -p ./bin
	curl -sSL --fail --retry 5 \
		"https://storage.googleapis.com/k8s-artifacts-cri-tools/release/v{{ .Version }}/crictl-v{{ .Version }}-linux-{{ .GoArch }}.tar.gz" \
		| tar -C ./bin -xz
	dh_testroot
	dh_auto_install
	dh_shlibdeps
	dh_install
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

%:
	dh $@
