=== release@v0.9.0/cmd/kubepkg/templates/latest/deb/kubeadm/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
KUBE_LOCAL_ARTIFACTS?=

build:
	echo noop

binary:
	mkdir -p usr/bin
ifneq ($(KUBE_LOCAL_ARTIFACTS),)
	cp $(KUBE_LOCAL_ARTIFACTS)/bin/linux/{{ .GoArch }}/kubeadm usr/bin/kubeadm
else
	curl --fail -sSL --retry 5 \
		-o usr/bin/kubeadm \
		"{{ .DownloadLinkBase }}/bin/linux/{{ .GoArch }}/kubeadm"
endif

	chmod +x usr/bin/kubeadm
	dh_testroot
	dh_auto_install
	dh_shlibdeps
	dh_install
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

%:
	dh $@
